/*
 * Copyright 2002-2008 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.springframework.config.java.plugin.context;

import org.springframework.beans.factory.support.BeanDefinitionRegistry;
import org.springframework.config.java.plugin.ConfigurationPlugin;


/** TODO: JAVADOC */
class MBeanExportHandler implements ConfigurationPlugin<MBeanExport> {

    public void handle(MBeanExport annotation, BeanDefinitionRegistry registry) {
        MBeanExportDeclaration declaration = new MBeanExportDeclaration();

        declaration.setRegistrationPolicy(annotation.registration());
        declaration.setDefaultDomain(annotation.defaultDomain());
        declaration.setServerBeanName(annotation.server());

        new MBeanExportBeanDefinitionParser().parse(declaration, registry);
    }

}
